#include <windows.h>

#include <stdio.h>
#include <time.h>
#include <assert.h>

// G[R[h
#define SPI_SUCCESS			0		// I
#define SPI_NOT_IMPLEMENT	(-1)	// ̋@\̓CvgĂȂ
#define SPI_USER_CANCEL		1		// R[obN֐0Ԃ̂œWJ𒆎~
#define SPI_UNKNOWN_FORMAT	2		// m̃tH[}bg
#define SPI_DATA_BROKEN		3		// f[^Ă
#define SPI_NO_MEMORY		4		// [mۏoȂ
#define SPI_MEMORY_ERR		5		// [G[iLockoȂAj
#define SPI_FILE_READ_ERR	6		// t@C[hG[
#define SPI_RESERVED_ERR	7		// i\j
#define SPI_INTERNAL_ERR	8		// G[

#include <pshpack1.h>
// t@C\
struct fileInfo
{
	unsigned char	method[8] ;		// k@̎
	unsigned long	position ;		// t@Cł̈ʒu
	unsigned long	compsize ;		// kꂽTCY
	unsigned long	filesize ;		// ̃t@CTCY
	time_t			timestamp ;		// t@C̍XV
	char			path[200] ;		// ΃pX
	char			filename[200] ;	// t@Cl[
	unsigned long	crc ;			// CRC
} ;
#include <poppack.h>

// DllMain
BOOL WINAPI DllMain( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved )
{
	return TRUE ;
}

// sǂݍ
static char * myfgets( char * pString, int n, FILE * fp )
{
	if ( pString == NULL || n <= 0 || fp == NULL )
		return NULL ;
	if ( ::fgets( pString, n, fp ) == NULL )
		return NULL ;

	// CRLF΍
	size_t	len = ::strlen( pString ) ;
	if ( len >= 2 )
	{
		if ( pString[len-2] == '\r' && pString[len-1] == '\n' )
			pString[len-2] = '\0' ;
	}

	return pString ;
}

//////////////////////////////////////////////////////////////////////////////
// Plug-in API
//////////////////////////////////////////////////////////////////////////////

int __stdcall GetPluginInfo( int infono, LPSTR buf, int buflen )
{
	if ( buf == NULL || buflen <= 0 )
		return 0 ;

	if ( infono == 0 )
		return ::strlen( ::lstrcpyn( buf, "00AM", buflen ) ) ;
	else if ( infono == 1 )
		return ::strlen( ::lstrcpyn( buf, "axpathlist", buflen ) ) ;
	else if ( infono == 2 )
		return ::strlen( ::lstrcpyn( buf, "*.sz7", buflen ) ) ;
	else if ( infono == 3 )
		return ::strlen( ::lstrcpyn( buf, "pXXg (*.sz7)", buflen ) ) ;

	return 0 ;
}

#define SPI_SUPPORT_TRUE	1
#define SPI_SUPPORT_FALSE	0
int __stdcall IsSupported( LPSTR filename, DWORD dw )
{
	void *	pBuffer = NULL ;
	__try
	{
		// ׂf[^obt@擾
		LPCSTR	pPathList = NULL ;
		if ( HIWORD(dw) )
		{
			// obt@ւ̃|C^
			pPathList = (LPCSTR)dw ;
		}
		else
		{
			// t@Cnh
			HANDLE	hFile = (HANDLE)dw ;
			pBuffer = ::calloc( 2048, 1 ) ;
			if ( pBuffer == NULL )
				return SPI_SUPPORT_FALSE ;
			DWORD	readBytes ;
			::ReadFile( hFile, pBuffer, 2048, &readBytes, NULL ) ;
			pPathList = (LPCSTR)pBuffer ;
		}

		// f[^obt@`FbN
		assert( pPathList != NULL ) ;
		if ( pPathList[1] != ':' || pPathList[2] != '\\' )
			return SPI_SUPPORT_FALSE ;
		for ( UINT i = 3 ; i < _MAX_PATH ; i ++ )
		{
			assert( i+1 < 2048 ) ;
			if ( pPathList[i] == '\0' )
				break ;
			if ( ::IsDBCSLeadByte( pPathList[i] ) )
				i ++ ;
			else if ( pPathList[i] == '\r' && pPathList[i+1] == '\n' )
				return SPI_SUPPORT_TRUE ;
		}
	}
	__finally
	{
		if ( pBuffer != NULL )
			::free( pBuffer ) ;
	}
	return SPI_SUPPORT_FALSE ;
}

int __stdcall GetArchiveInfo( LPSTR buf, long len, unsigned int flag, HLOCAL * lphInf )
{
	if ( lphInf == NULL )
		return SPI_INTERNAL_ERR ;
	if ( flag & 0x0007 )
		return SPI_NOT_IMPLEMENT ;	// ̃C[Wɂ͑ΉȂ
	int			errCode = SPI_INTERNAL_ERR ;
	FILE *		fp = NULL ;
	HLOCAL		hArchiveInfo = NULL ;
	fileInfo *	pFileInfo = NULL ;
	__try
	{
		// t@C擾
		fp = ::fopen( buf, "rb" ) ;
		if ( fp == NULL )
			return SPI_INTERNAL_ERR ;
		UINT	fileNum = 0 ;
		char	buffer[_MAX_PATH] ;
		::fseek( fp, len, SEEK_SET ) ;
		while ( ::myfgets( buffer, _MAX_PATH, fp ) != NULL )
		{
			DWORD	attributes = ::GetFileAttributes( buffer ) ;
			if ( attributes != 0xFFFFFFFF && !( attributes & FILE_ATTRIBUTE_DIRECTORY ) )
				fileNum ++ ;
		}
		if ( fileNum == 0 )
			return SPI_INTERNAL_ERR ;

		// ɏ擾
		hArchiveInfo = ::LocalAlloc( LHND, sizeof(fileInfo)*(fileNum+1) ) ;
		if ( hArchiveInfo == NULL )
			return SPI_NO_MEMORY ;
		pFileInfo = (fileInfo *)::LocalLock( hArchiveInfo ) ;
		if ( pFileInfo == NULL )
			return SPI_MEMORY_ERR ;
		ULONG	position = len ;
		::fseek( fp, len, SEEK_SET ) ;
		while ( ::myfgets( buffer, _MAX_PATH, fp ) != NULL )
		{
			HANDLE	hFile = ::CreateFile(
				buffer, GENERIC_READ, FILE_SHARE_READ,
				NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
			if ( hFile != INVALID_HANDLE_VALUE )
			{
				// t@C擾
				DWORD		fileSize = ::GetFileSize( hFile, NULL ) ;
				FILETIME	fileTime ;
				::GetFileTime( hFile, NULL, NULL, &fileTime ) ;
				::CloseHandle( hFile ) ;
				time_t		timestamp = (time_t)( ( (*(PUINT64)&fileTime) - 0x19DB1DED53E8000 ) / 10000000 ) ;
				char		fname[_MAX_FNAME] ;
				char		ext[_MAX_EXT] ;
				::_splitpath( buffer, NULL, NULL, fname, ext ) ;

				// t@Cݒ
				pFileInfo->method[0]	= 'a' ;				// k@̎(method[0]'\0'łȂ΃CC)
				pFileInfo->method[1]	= '\0' ;			// k@̎
				pFileInfo->position		= position ;		// t@Cł̈ʒu
				pFileInfo->compsize		= fileSize ;		// kꂽTCY
				pFileInfo->filesize		= fileSize ;		// ̃t@CTCY
				pFileInfo->timestamp	= timestamp ;		// t@C̍XV
				pFileInfo->path[0]		= '\0' ;			// ΃pX
				::strcpy( pFileInfo->filename, fname ) ;	// t@Cl[
				::strcat( pFileInfo->filename, ext ) ;		// t@Cl[
				pFileInfo->crc			= 0 ;				// CRC
				pFileInfo ++ ;
			}
			fpos_t	pos ;
			::fgetpos( fp, &pos ) ;
			position = (ULONG)pos ;
		}
		*lphInf = hArchiveInfo ;
		errCode = SPI_SUCCESS ;
	}
	__finally
	{
		if ( fp != NULL )
			::fclose( fp ) ;
		if ( pFileInfo != NULL )
		{
			assert( hArchiveInfo != NULL ) ;
			::LocalUnlock( hArchiveInfo ) ;
		}
		if ( errCode != SPI_SUCCESS )
		{
			if ( hArchiveInfo != NULL )
				::LocalFree( hArchiveInfo ) ;
			*lphInf = NULL ;
		}
	}
	return errCode ;
}

int __stdcall GetFileInfo( LPSTR buf, long len, LPSTR filename, unsigned int flag, fileInfo * lpInfo )
{
	if ( lpInfo == NULL )
		return SPI_INTERNAL_ERR ;
	if ( flag & 0x0007 )
		return SPI_NOT_IMPLEMENT ;	// ̃C[Wɂ͑ΉȂ
	FILE *	fp = NULL ;
	__try
	{
		// t@C񌟍
		fp = ::fopen( buf, "rb" ) ;
		if ( fp == NULL )
			return SPI_INTERNAL_ERR ;
		char	buffer[_MAX_PATH] ;
		ULONG	position = len ;
		::fseek( fp, len, SEEK_SET ) ;
		while ( ::myfgets( buffer, _MAX_PATH, fp ) != NULL )
		{
			char	name[_MAX_FNAME] ;
			char	fname[_MAX_FNAME] ;
			char	ext[_MAX_EXT] ;
			::_splitpath( buffer, NULL, NULL, fname, ext ) ;
			::strcpy( name, fname ) ;
			::strcat( name, ext ) ;
			if ( !::strcmp( name, filename ) )
			{
				// t@C擾
				HANDLE	hFile = ::CreateFile(
					buffer, GENERIC_READ, FILE_SHARE_READ,
					NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
				if ( hFile == INVALID_HANDLE_VALUE )
					break ;
				DWORD		fileSize = ::GetFileSize( hFile, NULL ) ;
				FILETIME	fileTime ;
				::GetFileTime( hFile, NULL, NULL, &fileTime ) ;
				::CloseHandle( hFile ) ;
				time_t		timestamp = (time_t)( ( (*(PUINT64)&fileTime) - 0x19DB1DED53E8000 ) / 10000000 ) ;

				// t@Cݒ
				lpInfo->method[0]	= 'a' ;					// k@̎(method[0]'\0'łȂ΃CC)
				lpInfo->method[1]	= '\0' ;				// k@̎
				lpInfo->position	= position ;			// t@Cł̈ʒu
				lpInfo->compsize	= fileSize ;			// kꂽTCY
				lpInfo->filesize	= fileSize ;			// ̃t@CTCY
				lpInfo->timestamp	= timestamp ;			// t@C̍XV
				lpInfo->path[0]		= '\0' ;				// ΃pX
				::strcpy( lpInfo->filename, filename ) ;	// t@Cl[
				lpInfo->crc			= 0 ;					// CRC
				return SPI_SUCCESS ;
			}
			fpos_t	pos ;
			::fgetpos( fp, &pos ) ;
			position = (ULONG)pos ;
		}
	}
	__finally
	{
		if ( fp != NULL )
			::fclose( fp ) ;
	}
	return SPI_INTERNAL_ERR ;
}

int __stdcall GetFile( LPSTR src, long len, LPSTR dest, unsigned int flag, FARPROC progressCallback, long lData )
{
	if ( src == NULL || dest == NULL )
		return SPI_INTERNAL_ERR ;
	if ( flag & 0x0007 )
		return SPI_NOT_IMPLEMENT ;	// ̃C[Wɂ͑ΉȂ

	// t@CpX擾
	FILE *	fp = ::fopen( src, "rb" ) ;
	if ( fp == NULL )
		return SPI_INTERNAL_ERR ;
	char	path[_MAX_PATH] ;
	::fseek( fp, len, SEEK_SET ) ;
	if ( ::myfgets( path, _MAX_PATH, fp ) == NULL )
	{
		::fclose( fp ) ;
		return SPI_UNKNOWN_FORMAT ;
	}
	::fclose( fp ) ;

	// t@Co
	int	errCode = SPI_INTERNAL_ERR ;
	if ( ( flag >> 8 ) & 0x0007 )
	{
		// ̃C[WƂďo
		HANDLE	hFile = INVALID_HANDLE_VALUE ;
		HLOCAL	hFileData = NULL ;
		__try
		{
			hFile = ::CreateFile(
				path, GENERIC_READ, FILE_SHARE_READ,
				NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
			if ( hFile == INVALID_HANDLE_VALUE )
				__leave ;
			DWORD	fileSize = ::GetFileSize( hFile, NULL ) ;
			if ( fileSize == 0 )
				__leave ;
			hFileData = ::LocalAlloc( LHND, fileSize ) ;
			if ( hFileData == NULL )
				return SPI_NO_MEMORY ;
			LPVOID	pFileData = ::LocalLock( hFileData ) ;
			if ( pFileData == NULL )
				return SPI_MEMORY_ERR ;
			DWORD	readBytes ;
			::ReadFile( hFile, pFileData, fileSize, &readBytes, NULL ) ;
			::LocalUnlock( hFileData ) ;
			if ( readBytes != fileSize )
				return SPI_FILE_READ_ERR ;
			*(HLOCAL *)dest = hFileData ;
			errCode = SPI_SUCCESS ;
		}
		__finally
		{
			if ( hFile != INVALID_HANDLE_VALUE )
				::CloseHandle( hFile ) ;
			if ( errCode != SPI_SUCCESS )
			{
				if ( hFileData != NULL )
					::LocalFree( hFileData ) ;
				*dest = NULL ;
			}
		}
	}
	else
	{
		// fBXNt@CƂďo
		errCode = SPI_NOT_IMPLEMENT ;	// 
	}

	return errCode ;
}


